#include "audio.h"
#include "sensor.h"

AUDIO_INFO g_AUDIO_INFO;

void initAUDIO(void)
{
	g_AUDIO_INFO.state = (AUDIO_STATE_IDLE);
	g_AUDIO_INFO.cap_size = (AUDIO_MAX_CAPTURE_SIZE);
	g_AUDIO_INFO.stop = 0;
	initPDM();
}

void chkAUDIO(void)
{
	switch(g_AUDIO_INFO.state)
	{
		case(AUDIO_STATE_IDLE):
		{
			break;
		}
		case(AUDIO_STATE_INIT):
		{
			//stopPDM();
			
			g_SENSOR_INFO.accel_reinit_cnt = 0;
			g_AUDIO_INFO.idle_cnt = 0;
			g_AUDIO_INFO.widx = 0;
			g_AUDIO_INFO.ridx = 0;
			if(g_AUDIO_INFO.cap_size > (AUDIO_MAX_CAPTURE_SIZE))
			{
				g_AUDIO_INFO.cap_size = (AUDIO_MAX_CAPTURE_SIZE);
			}
			printk("-> AUD: capture initiated for %d samples\n", g_AUDIO_INFO.cap_size);
			//g_AUDIO_INFO.widx = g_AUDIO_INFO.cap_size;
			g_AUDIO_INFO.state = (AUDIO_STATE_WAIT4CAPTURE_END);
			clearAccelFifoSENSOR();
			//begSENSOR();
			startPDM();
			uint8_t pkt[2];
			pkt[0] = AUDIO_STREAMING_STATUS;
			pkt[1] = AUDIO_STREAMING_INIT;
			txSensorPktBLE(pkt, 2);
			
			
			//// [*][AG][TESTING ADDED]
			//g_AUDIO_INFO.widx = g_AUDIO_INFO.cap_size;
			//pkt[0] = AUDIO_STREAMING_STATUS;
			//pkt[1] = AUDIO_STREAMING_COMPLETE;
			//txSensorPktBLE(pkt, 2);
			//g_AUDIO_INFO.state = (AUDIO_STATE_CAPTURE_COMPLETED);
			//printk("-> AUD: capture completed for %d samples\n", g_AUDIO_INFO.cap_size);
			//// [*]
			
			break;
		}
		case(AUDIO_STATE_WAIT4CAPTURE_END):
		{
			break;
		}
		case(AUDIO_STATE_CAPTURE_COMPLETED):
		{
			break;
		}
		default:
		{
			break; 
		}
	}
}

void restartAUDIO(void)
{
	stopPDM();
	g_AUDIO_INFO.idle_cnt = 0;
	g_AUDIO_INFO.stop = 0;
	g_AUDIO_INFO.widx = 0;
	g_AUDIO_INFO.ridx = 0;
	if(g_AUDIO_INFO.cap_size > (AUDIO_MAX_CAPTURE_SIZE))
	{
		g_AUDIO_INFO.cap_size = (AUDIO_MAX_CAPTURE_SIZE);
	}
	printk("-> AUD: capture restarted, attempt %d/%d\n", g_SENSOR_INFO.accel_reinit_cnt,SENSOR_ACCEL_REINIT_MAX_CNT);
	//g_AUDIO_INFO.widx = g_AUDIO_INFO.cap_size;
	g_AUDIO_INFO.state = (AUDIO_STATE_WAIT4CAPTURE_END);
	clearAccelFifoSENSOR();
	startPDM();
	
	uint8_t pkt[2];
	pkt[0] = AUDIO_STREAMING_STATUS;
	pkt[1] = AUDIO_STREAMING_REINIT;
	txSensorPktBLE(pkt, 2);
}

void stopAUDIO(void)
{
	if(g_AUDIO_INFO.stop)
	{
		return;
	}
	
	g_AUDIO_INFO.stop = 1;
	g_AUDIO_INFO.idle_cnt = 0;
	stopPDM();
	
	g_AUDIO_INFO.widx = 0;
	g_AUDIO_INFO.ridx = 0;
	if(g_AUDIO_INFO.cap_size > (AUDIO_MAX_CAPTURE_SIZE))
	{
		g_AUDIO_INFO.cap_size = (AUDIO_MAX_CAPTURE_SIZE);
	}
	printk("-> AUD: capture stopped due to vibration...\n");
}
