#ifndef __DELAY_H__
#define __DELAY_H__

#include <stdint.h>
#include <time.h>
#include "mcu.h"

#define SYSTIM_TIMEOUT				0
#define SYSTIM_KEEP_ALIVE			1

#define CLOCK_HF				0
#define CLOCK_LF				1


void 		startCLOCK(uint8_t clock);
void 		stopCLOCK(uint8_t clock);

void 		initSYSTIM(uint32_t led_period);
uint8_t 	chk4TimeoutSYSTIM(uint32_t t_beg, uint32_t t_period);
uint32_t 	getElapsedTimeSYSTIM(uint32_t t_beg);
uint32_t 	getSYSTIM(void);
void 		deinitRTC2(void);

void 		delay_ms(uint32_t ms);
void		delay_us(uint32_t us);
void 		startSWATCH(void);
uint32_t 	stopSWATCH(void);

uint8_t 	getDateSYSTIME(time_t timestamp, uint8_t type);
void 		setExpDateSYSTIME(uint32_t timestamp);
uint32_t 	getDATETIME1(uint32_t timedate, uint8_t type);

extern volatile uint32_t g_rtc_time;
#endif
