#include "sensor.h"
#include "ADXL345.h"

volatile SENSOR_INFO g_SENSOR_INFO; 
struct k_poll_signal signal_accel_action;

void accel_timer_handler(struct k_timer *timer_id)
{
	if(g_AUDIO_INFO.state == (AUDIO_STATE_WAIT4CAPTURE_END))
	{
		//printk("-> SENSOR: accel handler...\n");
		//uint16_t x = 0, y = 0, z = 0;
		// add your accelerometer function to collect the data 
		// readACCEL(x,y,z);
		//x = getX();
		//y = getY();
		//z = getZ();
         
		// now we add the collected accelerometer data to the FIFO
		//procAccelDataSENSOR(x, y, z);
		
		k_poll_signal_raise(&signal_accel_action, 0);
	}
}

K_TIMER_DEFINE(accel_timer, accel_timer_handler, NULL);

void initSENSOR(void)
{	
	I2C_routine();
	k_msleep(500);

	begSENSOR();
	printk("-> SENSOR: init done\n");
}

void begSENSOR(void)
{
	Enable_Meas();
	setRange(ADXL345_RANGE_16_G);
	
	//while(1)
	//{
		//uint16_t x = 0, y = 0, z = 0;
		//x = getX();
		//y = getY();
		//z = getZ();
		//printk("-> SYS: %d %d %d\n",x,y,z);
		//k_msleep(500);
	//}
	
	clearAccelFifoSENSOR();
	k_timer_start(&accel_timer, K_MSEC(100), K_MSEC(100));
	
	printk("-> ACCEL: enabled\n");
}

void endSENSOR(void)
{
	return;
	Disable_Meas();	
	k_timer_stop(&accel_timer);
	
	printk("-> ACCEL: disabled\n");
}

void clearAccelFifoSENSOR(void)
{
	uint16_t k;
	
	g_SENSOR_INFO.accel_widx = 0;
	g_SENSOR_INFO.accel_x_avr = 0;
	g_SENSOR_INFO.accel_y_avr = 0;
	g_SENSOR_INFO.accel_z_avr = 0;
	g_SENSOR_INFO.prev_rflag = 0;
	for(k=0;k<(ACCEL_BUFFER_SIZE);k++)
	{
		g_SENSOR_INFO.accel_x_data[k] = 0;
		g_SENSOR_INFO.accel_y_data[k] = 0;
		g_SENSOR_INFO.accel_y_data[k] = 0;
	}
}

void procAccelDataSENSOR(uint16_t x, uint16_t y, uint16_t z)
{
	g_SENSOR_INFO.accel_x_data[g_SENSOR_INFO.accel_widx] = x;
	g_SENSOR_INFO.accel_y_data[g_SENSOR_INFO.accel_widx] = y;
	g_SENSOR_INFO.accel_y_data[g_SENSOR_INFO.accel_widx] = z;
	
	g_SENSOR_INFO.accel_widx++;
	if(g_SENSOR_INFO.accel_widx >= (ACCEL_BUFFER_SIZE))
	{
		g_SENSOR_INFO.accel_widx = 0;
	}

	// 1. calculate the mean values for each sensor
	int32_t accel_x_avr = 0;
	int32_t accel_y_avr = 0;
	int32_t accel_z_avr = 0;
	uint16_t k;
	uint8_t rflag = 0;
	for(k=0;k<(ACCEL_BUFFER_SIZE);k++)
	{
		accel_x_avr += g_SENSOR_INFO.accel_x_data[k];
		accel_y_avr += g_SENSOR_INFO.accel_y_data[k];
		accel_z_avr += g_SENSOR_INFO.accel_z_data[k];
	}
	accel_x_avr = accel_x_avr/(ACCEL_BUFFER_SIZE);
	accel_y_avr = accel_y_avr/(ACCEL_BUFFER_SIZE);
	accel_z_avr = accel_z_avr/(ACCEL_BUFFER_SIZE);
	
	if(((g_SENSOR_INFO.accel_x_avr + (ACCEL_X_DELTA)) <  accel_x_avr)||(g_SENSOR_INFO.accel_x_avr > ((ACCEL_X_DELTA) + accel_x_avr)))
	{
		rflag = 1;
	}
	
	if(((g_SENSOR_INFO.accel_y_avr + (ACCEL_Y_DELTA)) <  accel_y_avr)||(g_SENSOR_INFO.accel_y_avr > ((ACCEL_Y_DELTA) + accel_y_avr)))
	{
		rflag = 1;
	}
	
	if(((g_SENSOR_INFO.accel_z_avr + (ACCEL_Z_DELTA)) <  accel_z_avr)||(g_SENSOR_INFO.accel_z_avr > ((ACCEL_Z_DELTA) +  accel_z_avr)))
	{
		rflag = 1;
	}
	g_SENSOR_INFO.accel_x_avr = accel_x_avr;
	g_SENSOR_INFO.accel_y_avr = accel_y_avr;
	g_SENSOR_INFO.accel_z_avr = accel_z_avr;
	
	if(rflag)
	{
		printk("-> SENSOR: VIBRATION DETECTED \n");
	}
	if(g_AUDIO_INFO.state == (AUDIO_STATE_WAIT4CAPTURE_END))
	{
		if(rflag)
		{
			stopAUDIO();
		}
		
		
		if((g_AUDIO_INFO.stop == 1) && (rflag == 0))
		{
			g_AUDIO_INFO.idle_cnt++;
			if(g_AUDIO_INFO.idle_cnt >= (SENSOR_IDLE_PERIOD))
			{
				g_SENSOR_INFO.accel_reinit_cnt++;
				if(g_SENSOR_INFO.accel_reinit_cnt < (SENSOR_ACCEL_REINIT_MAX_CNT))
				{
					// restart the audio capture and send the notification
					restartAUDIO();		
				}
				else
				{
					// stop the whole process
					g_AUDIO_INFO.state = (AUDIO_STATE_IDLE);
				}
			}
		}
		else
		{
			g_AUDIO_INFO.idle_cnt = 0; 
		}
	}
	
	
	g_SENSOR_INFO.prev_rflag = rflag;
}



