#include "spi.h"


uint8_t initSPI1(void)
{	
	NRF_P0->PIN_CNF[SPI_DCX] = 0x00000301;
    NRF_P0->OUTSET = (1<<(SPI_DCX));
	
	NRF_P1->PIN_CNF[SPI1_CS] = 0x00000301;
	setCsSPI1(1);	
 
	NRF_P1->PIN_CNF[SPI1_SCK] = 0x00000301;										// set as output
	NRF_P1->PIN_CNF[SPI1_MISO] = 0x00000000;									// set as input
	NRF_P1->PIN_CNF[SPI1_MOSI] = 0x00000301;									// set as output
	
	NRF_P1->OUTCLR = (1<<(SPI1_SCK)); 
	NRF_P1->OUTCLR = (1<<(SPI1_MOSI));	

    return 0;
}

void deinitSPI1(void)
{///										
	NRF_P1->PIN_CNF[SPI1_CS] = 0x00000002;										// set as input, disconnect input
	NRF_P1->PIN_CNF[SPI1_SCK] = 0x00000002;										// set as input, disconnect input
	NRF_P1->PIN_CNF[SPI1_MISO] = 0x00000002;									// set as input, disconnect input
	NRF_P1->PIN_CNF[SPI1_MOSI] = 0x00000002;									// set as input, disconnect input
}

void txByteSSPI(uint8_t data)
{
	uint8_t k;
	for(k=0;k<8;k++)
	{
		NRF_P1->OUTCLR = (1<<(SPI1_SCK));
		delaySPI();
		if(data & 0x80)
		{
			NRF_P1->OUTSET = (1<<(SPI1_MOSI));
		}
		else
		{	
			NRF_P1->OUTCLR = (1<<(SPI1_MOSI));
		}
		NRF_P1->OUTSET = (1<<(SPI1_SCK));
		delaySPI();
		
		data = data<<1;
	}
	NRF_P1->OUTCLR = (1<<(SPI1_SCK));
}

uint8_t rxByteSSPI(void)
{
	uint8_t k;
	uint8_t data = 0x00;
	for(k=0;k<8;k++)
	{
		data = data<<1;
		NRF_P1->OUTCLR = (1<<(SPI1_SCK));
		delaySPI();
		NRF_P1->OUTSET = (1<<(SPI1_SCK));
		delaySPI();
		if(NRF_P1->IN & (1<<(SPI1_MISO)))
		{
			data |= 0x01;
		}
	}
	NRF_P1->OUTCLR = (1<<(SPI1_SCK));
	
	return data;
}


uint8_t txDataSPI1(uint8_t * tx_data, uint32_t tx_size)
{///
	uint32_t k;
	for(k=0;k<tx_size;k++)
	{
		txByteSSPI(tx_data[k]);
	}
   
    return 1;
}

uint8_t rxDataSPI1(uint8_t * rx_data, uint32_t rx_size)
{///
    uint32_t k;
    for(k=0;k<rx_size;k++)
    {
		rx_data[k] = rxByteSSPI();
	}
    
    return 1;
}

void delaySPI(void)
{
	__asm volatile("nop;nop;");
	//__asm("nop;nop;nop;nop;");
	//__asm("nop;nop;nop;nop;nop;nop;nop;nop;");
	//__asm("nop;nop;nop;nop;nop;nop;nop;nop;");
}

void setCsSPI1(uint8_t state)
{
	if(state)
	{
		NRF_P1->OUTSET = (1<<(SPI1_CS));
	}
	else
	{
		NRF_P1->OUTCLR = (1<<(SPI1_CS));
	}
}
